// http://www.purple.dti.ne.jp/~t-ogura/animeEffect 
// LiveHatching A^C`GtFNgvO@openCV
// AviUtlvOC܂

#include <windows.h>
#include "cv.h"
#include "highgui.h"
#include <stdio.h>		// printf() / scanf()
#define _USE_MATH_DEFINES
#include <math.h>
#include "filter.h"

#include <io.h>
#include <string>
#include <map>

#ifndef _DEBUG
#pragma comment(lib,"cv.lib")
#pragma comment(lib,"cvaux.lib")
#pragma comment(lib,"cxcore.lib")
#pragma comment(lib,"highgui.lib")
#else
#pragma comment(lib,"cvd.lib")
#pragma comment(lib,"cvauxd.lib")
#pragma comment(lib,"cxcored.lib")
#pragma comment(lib,"highguid.lib")
#endif

#define YC2R(Y,Cb,Cr) (Y + 1.402*Cr)
#define YC2G(Y,Cb,Cr) (Y - 0.344*Cb - 0.714*Cr)
#define YC2B(Y,Cb,Cr) (Y + 1.772*Cb)
#define RGB2Y(R,G,B) (0.299*R + 0.587*G + 0.114*B)
#define RGB2CB(R,G,B) (-0.169*R - 0.331*G + 0.500*B)
#define RGB2CR(R,G,B) (0.500*R - 0.419*G - 0.081*B)

// [min, max] ͈̔͂ɖOa
template <class T>
T Saturate(T v, T min, T max) {
	if (v < min) {
		return min;
	} else if (v > max) {
		return max;
	}
	return v;
}

template <>
int Saturate(int v, int min, int max) {
    v -= min;
    v &= ~(v >> 31);
    v += min;

    v -= max;
    v &=  (v >> 31);
    v += max;
    
    return v;
}


void CopyBufToCvBGRImg(
		PIXEL_YC *buf, IplImage *img,
		int x0, int y0, int w, int h, int x1, int y1, int mw, int mh
){
	int src,ix0,iy0,ix1,iy1;

	for(iy0 = y0; iy0 < y0 + h; iy0++) {
		iy1 = y1 + (iy0-y0);
		src = x0 + iy0 * mw;
		for(ix0 = x0,ix1 = x1; ix0 < x0 + w; ix0++) {
			int y  = buf[src].y;
			int cb = buf[src].cb;
			int cr = buf[src].cr;

			int r = ( 255*y + ( ((22881*cr>>16)+3) <<10) ) >>12;
			int g = ( 255*y + ( ((-5616*cb>>16)+(-11655*cr>>16)+3) <<10) ) >>12;
			int b = ( 255*y + ( ((28919*cb>>16)+3) <<10) ) >>12;

			CV_IMAGE_ELEM(img, unsigned char, iy1, ix1*3+0) = Saturate(b, 0, 255);
			CV_IMAGE_ELEM(img, unsigned char, iy1, ix1*3+1) = Saturate(g, 0, 255);
			CV_IMAGE_ELEM(img, unsigned char, iy1, ix1*3+2) = Saturate(r, 0, 255);
			src++;
			ix1++;
		}
	}
}

void CopyCvBGRImgToBuf(
		IplImage *img, PIXEL_YC *buf, 
		int x0, int y0, int w, int h, int x1, int y1, int mw, int mh
){
	int dst,ix0,iy0,ix1,iy1;
	PIXEL_YC yc;

	for(iy0 = y0; iy0 < y0 + h; iy0++) {
		iy1 = y1 + (iy0-y0);
		dst = x1 + iy1 * mw;
		for(ix0 = x0,ix1 = x1; ix0 < x0 + w; ix0++) {
			int r,g,b;
			b = CV_IMAGE_ELEM(img, unsigned char, iy0, ix0*3+0);
			g = CV_IMAGE_ELEM(img, unsigned char, iy0, ix0*3+1);
			r = CV_IMAGE_ELEM(img, unsigned char, iy0, ix0*3+2);
			yc.y =  ((4918*r+354)>>10) + ((9655*g+585)>>10) + ((1875*b+523)>>10);
			yc.cb = ((-2775*r+240)>>10) + ((-5449*g+515)>>10) + (( 8224*b+256)>>10);
			yc.cr = ((8224*r+256)>>10) + ((-6887*g+110)>>10) + ((-1337*b+646)>>10);

			buf[dst] = yc;
			dst++;
			ix1++;
		}
	}
}


inline int is_neg(int v) {
    return (((unsigned int)v) >> (sizeof(v)*8 - 1));
}

inline int modulo(int a, int b) {
	int m = a % b;
//	return m + b * is_neg(m);

	if (m >= 0) {
		return m;
	} else {
		return m + b;
	}
}

namespace bicubic {
	static const double a =	 -1.0;

	inline double cubic1(double x) {
		return (((a+2.0)*x - (a+3.0))*x)*x + 1.0;
	}
	inline double cubic2(double x) {
		return ((a * x - 5.0*a) * x + 8.0*a) * x - 4.0*a;
	}

	inline double cubic_sub(unsigned char *img,
							int x0, int x1, int x2, int x3,
							double w0, double w1, double w2, double w3) {
		double v0 = (double)img[x0];
		double v1 = (double)img[x1];
		double v2 = (double)img[x2];
		double v3 = (double)img[x3];
		return v0 * w0 + v1 * w1 + v2 * w2 + v3 * w3;
	}

	inline double v_bicubic(IplImage *img, double x, double y) {
		int zx = (int)x;
		int zy = (int)y;
		double rx = x - (double)zx;
		double ry = y - (double)zy;

		if (rx < 0.0) {
			zx--;
			rx += 1.0;
		}
		if (ry < 0.0) {
			zy--;
			ry += 1.0;
		}

		double wx0 = cubic2(1.0 + rx);
		double wx1 = cubic1(      rx);
		double wx2 = cubic1(1.0 - rx);
		double wx3 = cubic2(2.0 - rx);

		double wy0 = cubic2(1.0 + ry);
		double wy1 = cubic1(      ry);
		double wy2 = cubic1(1.0 - ry);
		double wy3 = cubic2(2.0 - ry);

		int zx0 = modulo(zx-1, img->width);
		int zx1 = (zx0 + 1) % img->width;
		int zx2 = (zx0 + 2) % img->width;
		int zx3 = (zx0 + 3) % img->width;

		int zy0 = modulo(zy-1, img->height);
		int zy1 = (zy0 + 1) % img->height;
		int zy2 = (zy0 + 2) % img->height;
		int zy3 = (zy0 + 3) % img->height;

		unsigned char *dat = (unsigned char*)img->imageData;
		int widthStep = img->widthStep;

		double vy0 = cubic_sub(dat + zy0 * widthStep, zx0,zx1,zx2,zx3, wx0,wx1,wx2,wx3);
		double vy1 = cubic_sub(dat + zy1 * widthStep, zx0,zx1,zx2,zx3, wx0,wx1,wx2,wx3);
		double vy2 = cubic_sub(dat + zy2 * widthStep, zx0,zx1,zx2,zx3, wx0,wx1,wx2,wx3);
		double vy3 = cubic_sub(dat + zy3 * widthStep, zx0,zx1,zx2,zx3, wx0,wx1,wx2,wx3);

		return vy0*wy0 + vy1*wy1 + vy2*wy2 + vy3*wy3;
	}
}
using namespace bicubic;


inline double v_bilinear(IplImage *img, double x, double y) {
	int zx = (int)x;
	int zy = (int)y;
	double rx = x - (double)zx;
	double ry = y - (double)zy;

	if (rx < 0.0) {
		zx--;
		rx += 1.0;
	}
	if (ry < 0.0) {
		zy--;
		ry += 1.0;
	}

	int zx0 = modulo(zx, img->width);
	int zy0 = modulo(zy, img->height);

	int zx1 = (zx0 + 1) % img->width;
	int zy1 = (zy0 + 1) % img->height;

	int widthStep = img->widthStep;

	double v00 = (double)(unsigned char)img->imageData[zy0 * widthStep + zx0];
	double v01 = (double)(unsigned char)img->imageData[zy0 * widthStep + zx1];
	double v10 = (double)(unsigned char)img->imageData[zy1 * widthStep + zx0];
	double v11 = (double)(unsigned char)img->imageData[zy1 * widthStep + zx1];

	return ((v00 * (1.0-rx) + v01 * rx) * (1.0-ry)) + ((v10 * (1.0-rx) + v11 * rx) * ry);
}


namespace param{
	static int X = 5;			// LineStep 傫ƃKNKN
	static int Y = 54;			// oo@傫Ɠ͑a
	static int Z = 0;			// LineLength	
	static int lineWidth = 1;	// ̑
	static int lineNoise = 15;	// ߐڃsNZƂ̔r臒lB0ȏɂƐr؂
	static double DARK = 1.0;	// GbW̐F̋Px

	static int VFlag = 0;		// K}␳݂ȁH
	static int hatchingType = 0;     // 0..normal 1..inverse 2..white-base
	static const int nPattern = 7;   // nb`Op^[
	static int drawMode = 3;
	static int drawFps = 0;
	static int patternOffset = 0;
	static IplImage *hatching_org[nPattern];
	static IplImage *hatching[nPattern];

	static int background = 0;		//wiPx
	static bool patInv = false;	//p^[]L

	static double inclination = -1.0;	//X
	static double incRange = 1.0;		//Xϓ
	static int	xRange  = 10000;	//xϓ
	static int	yRange  = 10000;	//yϓ
	static double hDenseMax  = 0;		//nb`OZx

	static double mDARK = 1.0;	// GbW̐F̋PxW
	static double addDARK = 0.0;

	static bool hatchingDiffuse = false; //nb`OgUL

	static bool hatchingIntrp = false; //nb`Op^[QƎ̕ԗL

	enum INTR_TYPE{
		INTR_NONE,
		INTR_BILINEAR,
		INTR_BICUBIC
	};
	enum INTR_TYPE hatchingIntrType = INTR_NONE; //nb`Op^[QƎ̕ԃ^Cv

	static int hatchingPtNo = -100;	//nb`Op^[̎

	static double hatchingMagn = 1.0;  //nb`Op^[̊g嗦
	static double hatchingRad  = 1.0;  //nb`Op^[̉]px(WA)

	struct hatchingTransform { //nb`Op^[ϊpW
		double a00;
		double a01;
		double a02;
		double a10;
		double a11;
		double a12;
	};
	static hatchingTransform hatchingTf;

	static double s_coef = 2.0;				// ʓxW
	static double v_coef = 1.0;				// xW

	static bool makeMask = false;			// }XN쐬[h

	static CvRNG rng_state;

	static bool cannyOn = false;
	static int cannyThr1 = 2000;
	static int cannyThr2 = 3000;
}
using namespace param;

static IplImage *img0 = NULL;
static IplImage *img1 = NULL;
static IplImage *hsv = NULL;  
static IplImage *grayImage = NULL;
static IplImage *binaryImage = NULL;

typedef struct PointTable{
	CvPoint p;
	CvScalar color;
} POINTTABLE;

static const int MAXPOINT = 100000;
static POINTTABLE pointTable[MAXPOINT];

// RGB̍v
double colorLen(CvScalar &x, CvScalar &y)
{
	double sum = 0;
	for(int i=0;i<3;i++){
		sum += abs(x.val[i] - y.val[i]);
	}
	return sum;
}

// image̍WʒuJ[
CvScalar getColor(IplImage* image, int x, int y)
{
	int index = y * image->widthStep + x * image->nChannels;
	unsigned char *data =  (unsigned char *)image->imageData;
	return CV_RGB(data[index+2],data[index+1],data[index+0]);
}

// WC[WOɂ\̂ꍇp
CvScalar getColorCheck(IplImage* image, int x, int y)
{
	if (x<0) x = 0;
	if (y<0) y = 0;
	if (x>=image->width) x = image->width-1;
	if (y>=image->height) y = image->height-1;
	return getColor(image, x, y);
}

void divScaler(CvScalar &s, double d)
{
	s.val[0] /= d;
	s.val[1] /= d;
	s.val[2] /= d;
	s.val[3] /= d;
}

void mulScaler(CvScalar &s, double d)
{
	s.val[0] *= d;
	s.val[1] *= d;
	s.val[2] *= d;
	s.val[3] *= d;
}

void muladdScaler(CvScalar &s, double d, double a)
{
	s.val[0] *= d;
	s.val[1] *= d;
	s.val[2] *= d;
	s.val[3] *= d;
	s.val[0] += a;
	s.val[1] += a;
	s.val[2] += a;
	s.val[3] += a;
}


//ߐڃsNZƂ̐F̍̍ől臒lr

int checkPoint(IplImage *image, int x, int y, double th)
{
	static struct { int x,y; } map[4] = { { 1,0 }, {-1,0}, { 0,1}, { 0,-1} };
	CvScalar color = getColor(image, x,y);
	for(int i = 0;i<4; i++){
		if (colorLen(color, getColorCheck(image, x+map[i].x, y + map[i].y)) > th) return 1;
	}
	return 0;
}
int setPoint(int index, CvPoint *point, CvScalar &color)
{
	if (index >= MAXPOINT) return 0;
	pointTable[index].p = *point;
	pointTable[index].color.val[0] = color.val[0];
	pointTable[index].color.val[1] = color.val[1];
	pointTable[index].color.val[2] = color.val[2];
	pointTable[index].color.val[3] = color.val[3];
	return 1;		
}
double clip(double x, double min, double max)
{
	if (x>max) return max;
	if (x<min) return min;
	return x;
}

// inputImageAbaseɍ plane 0,1,2:H,S,V 3:GrayScale̎
void drawEdge(IplImage* image,IplImage* base,int plane = 2)
{
	static CvMemStorage *memStorage0 =cvCreateMemStorage(0); 
	CvSeq *contourSeq0 = NULL;

	int height    = image->height;
	int width     = image->width;
	int step      = image->widthStep;
	int channels  = image->nChannels;
	uchar *data      = (uchar *)image->imageData;


	if (plane <3){
		cvCvtColor(image,hsv,CV_BGR2HSV);				// HSVplane搶̌ɂ
		for(int i=0;i<height*width;++i) grayImage->imageData[i] = hsv->imageData[i*3+plane];
	}else{
		cvCvtColor (image, grayImage, CV_BGR2GRAY);		// O[C[W搶̌ɂ
	}

	IplImage *target=base;					// ރ^[QbgC[W


	for(int x=20;x<240;x+=Y){
		if (!cannyOn) {
			cvThreshold( grayImage, binaryImage, x, 255, CV_THRESH_BINARY );	// x ̒lɂQl֊s𒊏o
		} else {
			cvCanny(grayImage, binaryImage, cannyThr1, cannyThr2, 5);	//CannyASYŗ֊so
		}
		contourSeq0 = 0;
		cvFindContours(binaryImage, memStorage0, &contourSeq0,sizeof(CvContour), CV_RETR_LIST, CV_CHAIN_APPROX_NONE, cvPoint(0,0)); // ֊sT
		
		if (lineNoise>0){ // sAC̏ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{
				CvPoint *p;
				if (contourSeq0->total<X*5) continue;		// 5p`ȉׂ͔̍̂r
				int index = 0;
				for( int i=0; i<contourSeq0->total; i+=X )
				{
					p = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, i);				// _̏ꏊƐFo^
					CvScalar color = getColor(image,p->x, p->y);
					muladdScaler(color,DARK,addDARK);										// PxC
					color.val[3] = checkPoint(image, p->x, p->y, lineNoise);	// L_ǂߐڃsNZ画f[3]֊i[
					setPoint(index,p,color);									// pointTable֕ۑ
					index++;
					if (index > MAXPOINT){
						printf("INDEX ERROR\n"); 
						index = 0;
					}
				}
				// TAȉ̗L_͖ iPending:j
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2,p3,p4,p0;
					if (pointTable[p1].color.val[3]){
						p2 = (p1+1)%index;
						p3 = (p1+2)%index;
						p4 = (p1+3)%index;
						p0 = (p1-1+index)%index;
						if (pointTable[p0].color.val[3]) continue;
						if (!pointTable[p2].color.val[3] ||
							!pointTable[p3].color.val[3] ||
							!pointTable[p4].color.val[3] ){						
							pointTable[p1].color.val[3] = 0;
						}
					}
				}
				// ڑꂽL_`
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2 = (i+1)%index;// if (p2==index) p2 = 0;
					if (pointTable[p1].color.val[3] && pointTable[p2].color.val[3])
					{
						CvScalar c;
						if (!makeMask) {
							c = pointTable[p1].color;
							muladdScaler(c,DARK,addDARK);
						} else {
							c.val[0] = c.val[1] = c.val[2] = 255;
						}
						cvLine(target,pointTable[p1].p,pointTable[p2].p,c,lineWidth,CV_AA );
					}
				}
			}
		}else{
			// S`ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{

				CvPoint *p1 = 0;
				CvPoint *p2;

				if (contourSeq0->total<X*5) continue;		

				for(int i=0; i<contourSeq0->total; i+=X ){
					p1 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i)%contourSeq0->total);//n_
					p2 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i+X+Z)%contourSeq0->total);// I_
					CvScalar color;
					if (!makeMask) {
						color = getColor(image,p1->x, p1->y);
						mulScaler(color,DARK);
					} else {
						color.val[0] = color.val[1] = color.val[2] = 255;
					}
					cvLine(target,*p1,*p2,color,lineWidth,CV_AA );
				}
			}
		}

		if (cannyOn) {	//Canny̏ꍇ͂P̂ݎs
			break;
		}
	}
	cvClearMemStorage(memStorage0);
}


// inputImageAbaseɍ plane 0,1,2:H,S,V 3:GrayScale̎
void drawEdge__(IplImage* image,IplImage* base,int plane = 2)
{
	static CvMemStorage *memStorage0 =cvCreateMemStorage(0); 
	CvSeq *contourSeq0 = NULL;

	int height    = image->height;
	int width     = image->width;
	int step      = image->widthStep;
	int channels  = image->nChannels;
	uchar *data      = (uchar *)image->imageData;


	if (plane <3){
		cvCvtColor(image,hsv,CV_BGR2HSV);				// HSVplane搶̌ɂ
		for(int i=0;i<height*width;++i) grayImage->imageData[i] = hsv->imageData[i*3+plane];
	}else{
		cvCvtColor (image, grayImage, CV_BGR2GRAY);		// O[C[W搶̌ɂ
	}

	IplImage *target=base;					// ރ^[QbgC[W

	//cvCanny(grayImage, binaryImage, X, Y, 7);
	//cvConvertImage(binaryImage, base);
	//return;

	for(int x=20;x<240;x+=1000){
		//cvThreshold( grayImage, binaryImage, x, 255, CV_THRESH_BINARY );	// x ̒lɂQl֊s𒊏o
		cvCanny(grayImage, binaryImage, cannyThr1, cannyThr2, 5);
		cvNamedWindow("canny",CV_WINDOW_AUTOSIZE);
		cvShowImage("canny", binaryImage);
		contourSeq0 = 0;
		cvFindContours(binaryImage, memStorage0, &contourSeq0,sizeof(CvContour), CV_RETR_LIST, CV_CHAIN_APPROX_NONE, cvPoint(0,0)); // ֊sT
		
		if (lineNoise>0){ // sAC̏ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{
				CvPoint *p;
				if (contourSeq0->total<X*5) continue;		// 5p`ȉׂ͔̍̂r
				int index = 0;
				for( int i=0; i<contourSeq0->total; i+=X )
				{
					p = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, i);				// _̏ꏊƐFo^
					CvScalar color = getColor(image,p->x, p->y);
					muladdScaler(color,DARK,addDARK);										// PxC
					color.val[3] = checkPoint(image, p->x, p->y, lineNoise);	// L_ǂߐڃsNZ画f[3]֊i[
					setPoint(index,p,color);									// pointTable֕ۑ
					index++;
					if (index > MAXPOINT){
						printf("INDEX ERROR\n"); 
						index = 0;
					}
				}
				// TAȉ̗L_͖ iPending:j
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2,p3,p4,p0;
					if (pointTable[p1].color.val[3]){
						p2 = (p1+1)%index;
						p3 = (p1+2)%index;
						p4 = (p1+3)%index;
						p0 = (p1-1+index)%index;
						if (pointTable[p0].color.val[3]) continue;
						if (!pointTable[p2].color.val[3] ||
							!pointTable[p3].color.val[3] ||
							!pointTable[p4].color.val[3] ){						
							pointTable[p1].color.val[3] = 0;
						}
					}
				}
				// ڑꂽL_`
				for(int i=0;i<index;i++){
					int p1 = i;
					int p2 = (i+1)%index;// if (p2==index) p2 = 0;
					if (pointTable[p1].color.val[3] && pointTable[p2].color.val[3])
					{
						CvScalar c;
						if (!makeMask) {
							c = pointTable[p1].color;
							muladdScaler(c,DARK,addDARK);
						} else {
							c.val[0] = c.val[1] = c.val[2] = (unsigned char)(255.0 * DARK);
						}
						cvLine(target,pointTable[p1].p,pointTable[p2].p,c,lineWidth,CV_AA );
					}
				}
			}
		}else{
			// S`ꍇ
			for(; contourSeq0 != 0; contourSeq0 = contourSeq0->h_next) 
			{

				CvPoint *p1 = 0;
				CvPoint *p2;

				if (contourSeq0->total<X*5) continue;		

				for(int i=0; i<contourSeq0->total; i+=X ){
					p1 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i)%contourSeq0->total);//n_
					p2 = CV_GET_SEQ_ELEM(CvPoint, contourSeq0, (i+X+Z)%contourSeq0->total);// I_
					CvScalar color;
					if (!makeMask) {
						color = getColor(image,p1->x, p1->y);
						mulScaler(color,DARK);
					} else {
						color.val[0] = color.val[1] = color.val[2] = (unsigned char)(255.0 * DARK);
					}
					cvLine(target,*p1,*p2,color,lineWidth,CV_AA );
				}
			}
		}
	}
	cvClearMemStorage(memStorage0);
}

// HatchingGtFNg
int drawHatching(IplImage *frame, IplImage *base)
{
	cvCvtColor(frame,hsv,CV_BGR2HSV);

	double rx = cvRandReal(&rng_state) * xRange;// texture offset
	double ry = cvRandReal(&rng_state) * yRange;
	double d =  (cvRandReal(&rng_state)-0.5)*incRange + inclination;//X

	int height    = frame->height;
	int width     = frame->width;

	double a00 = hatchingTf.a00;
	double a01 = hatchingTf.a01;
	double a02 = hatchingTf.a02;
	double a10 = hatchingTf.a10;
	double a11 = hatchingTf.a11;
	double a12 = hatchingTf.a12;


	int vtbl[256];
	for (int i=0; i<256; i++) {
		double V = (VFlag >= 0 ? (double)i : (255+VFlag)*i/255.0) / 255.0;
		V = pow(V, (10-VFlag)/10.0)*255.0;
		vtbl[i] = (int)V;
	}

	int fnChannels = frame->nChannels;
	int fwidthStep = frame->widthStep;

	for(int y=0;y<height;++y){
		int index_y = y * fwidthStep;

		for(int x=0;x<width;++x){
			int index = index_y + x*fnChannels;
			unsigned char v = hsv->imageData[index+2];
			v = vtbl[v];


			double X = x + rx;
			double Y = y + ry + (x*d);

			if (hatchingDiffuse) {
				X += cvRandReal(&rng_state)*2.0 - 1.0;
				Y += cvRandReal(&rng_state)*2.0 - 1.0;
			}

			double typeV;

			int maxV = nPattern-1+patternOffset;
			
			typeV = (255-v) / (256/maxV)-patternOffset;
			typeV = maxV-typeV ;

			if (typeV<0) typeV = 0;
			if (typeV>nPattern-1) typeV = nPattern-1;

			double vf = 0.0;
			int a = (int)typeV;
			int b = a+1;
			double w = typeV-a; // weight

			if (patInv){ // Inverse
				a = nPattern-1-a;
				b = nPattern-1-b;
			}

			double dx = a00 * X + a01 * Y + a02;
			double dy = a10 * X + a11 * Y + a12;

			switch (hatchingIntrType) {
				case INTR_NONE: {
					if (dx < 0.0) dx--;
					if (dy < 0.0) dy--;

					int aX = modulo((int)(dx+0.5), hatching[a]->width);
					int aY = modulo((int)(dy+0.5), hatching[a]->height);
					vf += ((unsigned char)hatching[a]->imageData[aX + aY * hatching[a]->widthStep]) * (1.0-w);
					if (b >=0 && b<=6){
						int bX = modulo((int)(dx+0.5), hatching[b]->width);
						int bY = modulo((int)(dy+0.5), hatching[b]->height);
						vf += ((unsigned char)hatching[b]->imageData[bX + bY * hatching[b]->widthStep]) * w;

					}
					break;
				}

				case INTR_BILINEAR:
					vf += v_bilinear(hatching[a], dx, dy)  * (1.0-w);
					if (b >=0 && b<=6){
						vf += v_bilinear(hatching[b], dx, dy) * w;
					}
					break;

				case INTR_BICUBIC:
					vf += v_bicubic(hatching[a], dx, dy) * (1.0-w);
					if (b >=0 && b<=6){
						vf += v_bicubic(hatching[b], dx, dy) * w;
					}
					vf = Saturate(vf, 0.0, 255.0);
					break;
			}

			double sf = s_coef;

			double vv = clip((unsigned char)hsv->imageData[index+2] * v_coef, 0.0, 255.0);
			if (hatchingType ==2){
				//int V = vv;V*=2;if (V>255)V=255;vv = V;// x[X𖾂邭Ă݂
				//vv = (unsigned char)clip(vv,0.0,255.0);
				vf=(vf*0.7+255.0*0.3); // ̂łƖ邭
			}
			else if (hatchingType == 3){ // 
				vv = 255.0;
				sf = 0.0;
				//vf=vf*0.7+255.0*0.3; // ̂łƖ邭
			}
			
			unsigned char newv;
			double vf2;

			switch (hatchingType) {
				case 0:
				case 1:
					vf2 = 1.0 - clip(vf*(1.0/255.0), 0.0, hDenseMax);
					newv = (unsigned char)(vv * vf2) ;
					break;

				case 4:
					vf2 = clip(vf*(1.0/255.0), 1.0-hDenseMax, 1.0);
					sf *= (1-vf2);
					newv = (unsigned char)clip(vv + (255.0-vv)*vf2, 0.0, 255.0);
					break;

				case 2:
				case 3:
					vf2 = clip(vf*(1.0/255.0), 1.0-hDenseMax, 1.0);
					newv = (unsigned char)(vv * vf2) ;
					break;
			}

			if (!makeMask) {
				base->imageData[index+0] = hsv->imageData[index+0];
				base->imageData[index+1] = (unsigned char)(Saturate((unsigned char)hsv->imageData[index+1] * sf, 0.0, 255.0));
				base->imageData[index+2] = newv ;
			} else {
				base->imageData[index+0] = 0;
				base->imageData[index+1] = 0;
				if (hatchingType == 2 || hatchingType == 3 || hatchingType == 4) {
					base->imageData[index+2] = 255 - (unsigned char)(255.0 * vf2);
				} else {
					base->imageData[index+2] = (unsigned char)(255.0 * vf2);
				}
			}
		}
	}
	cvCvtColor(base,base,CV_HSV2BGR);
	return 1;
}


static
void CopyImgWithMargin(
		IplImage *src, IplImage *dst, int margin
){
	int srcw = src->width;
	int srch = src->height;
	int srcws = src->widthStep;

	int dstw = dst->width;
	int dsth = dst->height;
	int dstws = dst->widthStep;

	/* byte per pixel */
	int bpp = (src->depth / 8) * src->nChannels;

	for (int dsty = 0; dsty < dsth; dsty++) {
		int srcy = modulo(dsty - margin, srch);
		char *psrcy = src->imageData + (srcws * srcy);
		char *pdsty = dst->imageData + (dstws * dsty);

		for (int dstx = 0; dstx < dstw;) {
			if (margin <= dstx && dstx < srcw + margin) {
				char *psrc = psrcy;
				char *pdst = pdsty + margin * bpp;
				memcpy(pdst, psrc, bpp*srcw);
				dstx += srcw;
			} else {
				int srcx = modulo(dstx - margin, srcw);
				char *psrc = psrcy + srcx * bpp;
				char *pdst = pdsty + dstx * bpp;
				memcpy(pdst, psrc, bpp);
				dstx++;
			}
		}
	}
}

static
void AffineTransform(
		IplImage *src, IplImage *dst, CvMat *mat
){
	int srcw = src->width;
	int srch = src->height;
	int srcws = src->widthStep;

	int dstw = dst->width;
	int dsth = dst->height;
	int dstws = dst->widthStep;

	/* byte per pixel */
	int bpp = (src->depth / 8) * src->nChannels;

	double a00 = cvGetReal2D(mat, 0, 0);
	double a01 = cvGetReal2D(mat, 0, 1);
	double a02 = cvGetReal2D(mat, 0, 2);
	double a10 = cvGetReal2D(mat, 1, 0);
	double a11 = cvGetReal2D(mat, 1, 1);
	double a12 = cvGetReal2D(mat, 1, 2);

	for (int dsty = 0; dsty < dsth; dsty++) {
		char *pdsty = dst->imageData + (dstws * dsty);

		for (int dstx = 0; dstx < dstw; dstx++) {
			double x = a00 * dstx + a01 * dsty + a02;
			double y = a10 * dstx + a11 * dsty + a12;

			int xx = modulo((int)x, srcw);
			int yy = modulo((int)y, srch);

			char *psrc = src->imageData + (srcws * yy + bpp * xx);
			char *pdst = pdsty + dstx * bpp;
			memcpy(pdst, psrc, bpp);
		}
	}
}



static char *g_dllpath = NULL;
static std::map<std::string, int> g_trackMap;
static std::map<std::string, int> g_checkMap;

static void ReleaseImages() {
	cvReleaseImage(&img0);
	cvReleaseImage(&img1);
	cvReleaseImage(&hsv);
	cvReleaseImage(&grayImage);
	cvReleaseImage(&binaryImage);
}

static void CreateImages(CvSize size) {
	img0		= cvCreateImage(size, IPL_DEPTH_8U, 3);
	img1		= cvCreateImage(size, IPL_DEPTH_8U, 3);
	hsv			= cvCreateImage(size, IPL_DEPTH_8U, 3);
	grayImage	= cvCreateImage(size, IPL_DEPTH_8U, 1);
	binaryImage	= cvCreateImage(size, IPL_DEPTH_8U, 1);
}

static void ReleaseHatchingPattern() {
	for(int i=0;i<nPattern;i++){
		if (hatching_org[i] != NULL) {
			cvReleaseImage(hatching_org + i);
			hatching_org[i] = NULL;
		}
		if (hatching[i] != NULL) {
			cvReleaseImage(hatching + i);
			hatching[i] = NULL;
		}
	}
}

static bool LoadHatchingPattern(char *errmsg) {
	char dir[8192];

	sprintf_s(dir, sizeof(dir), "%s/animEffect", g_dllpath);
	if (_access(dir, 0) != 0) {
		sprintf_s(dir, sizeof(dir), "%s", g_dllpath);
	}


	for(int i=0;i<nPattern;i++){
		char buf[8192];
		if (hatchingPtNo == 0) {
			sprintf_s(buf, sizeof(buf), "%s/img/h%d.bmp", dir, i);
		} else {
			sprintf_s(buf, sizeof(buf), "%s/img%d/h%d.bmp", dir, hatchingPtNo,  i);
		}

		if (hatching_org[i] != NULL) {
			cvReleaseImage(hatching_org + i);
		}

		hatching_org[i] = cvLoadImage(buf, CV_LOAD_IMAGE_GRAYSCALE);

		if (hatching_org[i] == NULL) {
			ReleaseHatchingPattern();
			sprintf_s(errmsg, 8192, "%s ̓ǂݍ݂Ɏs܂", buf);
			return false;
		}
	}
	return true;
}

static void InitHatchingPattern(FILTER *fp, FILTER_PROC_INFO *fpip) {
	double w = fpip->w;
	double h = fpip->h;

	double hw = hatching_org[0]->width;
	double hh = hatching_org[0]->height;

	double par1[] = {
		1.0, 0.0, -hw/2.0,
		0.0, 1.0, -hh/2.0,
		0.0, 0.0, 1.0
	};

	double par2[] = {
		1.0, 0.0, w/2.0,
		0.0, 1.0, h/2.0,
		0.0, 0.0, 1.0
	};

	double rot[] = {
		cos(hatchingRad), -sin(hatchingRad), 0.0,
		sin(hatchingRad),  cos(hatchingRad), 0.0,
		0.0, 0.0, 1.0
	};


	double exp[] = {
		1.0, 0.0, 0.0,
		0.0, 1.0, 0.0,
		0.0, 0.0, 1.0
	};
	if (hatchingMagn >= 1.0) {
		exp[0] = hatchingMagn;
		exp[4] = hatchingMagn;
	}

	double wk1[9];
	double wk2[9];
	double res[9];
	double inv[9];

	CvMat mpar1,mpar2,mrot,mexp;
	CvMat mwk1,mwk2,mres,minv;

	cvInitMatHeader(&mpar1, 3, 3, CV_64FC1, par1);
	cvInitMatHeader(&mpar2, 3, 3, CV_64FC1, par2);
	cvInitMatHeader(&mrot, 3, 3, CV_64FC1, rot);
	cvInitMatHeader(&mexp, 3, 3, CV_64FC1, exp);

	cvInitMatHeader(&mwk1, 3, 3, CV_64FC1, wk1);
	cvInitMatHeader(&mwk2, 3, 3, CV_64FC1, wk2);
	cvInitMatHeader(&mres, 3, 3, CV_64FC1, res);
	cvInitMatHeader(&minv, 3, 3, CV_64FC1, inv);


	cvMatMul(&mrot, &mpar1, &mwk1);
	cvMatMul(&mexp, &mwk1, &mwk2);
	cvMatMul(&mpar2, &mwk2, &mres);
	cvInvert(&mres, &minv, CV_LU);

	hatchingTf.a00 = inv[0];
	hatchingTf.a01 = inv[1];
	hatchingTf.a02 = inv[2];
	hatchingTf.a10 = inv[3];
	hatchingTf.a11 = inv[4];
	hatchingTf.a12 = inv[5];

	for(int i=0;i<nPattern;i++){
		if (hatching[i] != NULL) {
			cvReleaseImage(hatching + i);
		}

		if (hatchingMagn >= 1.0) {
			CvSize size = cvSize(hatching_org[i]->width, hatching_org[i]->height);
			hatching[i] = cvCreateImage(size, hatching_org[i]->depth, hatching_org[i]->nChannels);
			cvCopy(hatching_org[i], hatching[i]);

		} else {	
			CvSize size = cvSize(Saturate((int)(hatching_org[i]->width * hatchingMagn), 1, 2048), 
								 Saturate((int)(hatching_org[i]->height * hatchingMagn), 1, 2048));
			hatching[i] = cvCreateImage(size, hatching_org[i]->depth, hatching_org[i]->nChannels);
			cvResize(hatching_org[i], hatching[i], CV_INTER_AREA);
		}
	}
}


void InitAnimEffect(char *dllpath, FILTER_DLL *fdp) {
	g_dllpath = dllpath;

	g_trackMap.clear();
	for (int i=0; i<fdp->track_n; i++) {
		g_trackMap[fdp->track_name[i]] = i;
	}

	g_checkMap.clear();
	for (int i=0; i<fdp->check_n; i++) {
		g_checkMap[fdp->check_name[i]] = i;
	}

	hatchingPtNo = -100;
}

void UpdateAnimEffect(FILTER *fp, FILTER_PROC_INFO *fpip) {
	int no = fp->track[g_trackMap["݇"]];
	boolean no_changed = false;
	double magn = (double)fp->track[g_trackMap["g嗦"]] / 100.0;
	double rad  = ((double)fp->track[g_trackMap["]px"]]) * M_PI / 180.0;

	if (no != hatchingPtNo) {
		hatchingPtNo = no;
		no_changed = true;

		char errmsg[8192];
		bool ret;
		ret = LoadHatchingPattern(errmsg);
		if (!ret) {
			MessageBox(fp->hwnd, errmsg, "G[", MB_OK);
			return;
		}
	}

	if (hatching_org[0] == NULL) return;
	
	if (no_changed || 
		magn != hatchingMagn ||
		rad != hatchingRad
		) {

		hatchingMagn = magn;
		hatchingRad = rad;

		InitHatchingPattern(fp, fpip);
	}

}

void ExitAnimEffect() {
	ReleaseImages();
	ReleaseHatchingPattern();
}


BOOL ExecAnimEffect(FILTER *fp,FILTER_PROC_INFO *fpip) {

	PIXEL_YC *buffer0 = fpip->ycp_edit;
	PIXEL_YC *buffer1 = fpip->ycp_temp;

	int mw = fpip->max_w;
	int mh = fpip->max_h;
	int w = fpip->w;
	int h = fpip->h;

	int hatchingMode = fp->track[g_trackMap["Mode"]];
	param::X = fp->track[g_trackMap["LineStep"]];
	param::Y = fp->track[g_trackMap["oԊu"]];
	param::Z = fp->track[g_trackMap["Length"]];
	lineWidth = fp->track[g_trackMap["Width"]];
	lineNoise = fp->track[g_trackMap["Noise"]];
	VFlag = fp->track[g_trackMap["VFlag"]];
	mDARK = ((double)fp->track[g_trackMap["Zx"]])/100.0;
	inclination = ((double)fp->track[g_trackMap["X"]])/100.0;
	hDenseMax = (fp->track[g_trackMap["Zx"]])/100.0;
	int freq = fp->track[g_trackMap["XVԊu"]];
	int rseed = fp->track[g_trackMap[""]];
	incRange = ((double)fp->track[g_trackMap["Xϓ"]])/100.0;
	xRange = fp->track[g_trackMap["Xϓ"]];
	yRange = fp->track[g_trackMap["Yϓ"]];

	s_coef = ((double)fp->track[g_trackMap["ʓxW"]])/100.0;
	v_coef = ((double)fp->track[g_trackMap["xW"]])/100.0;

	cannyThr1 = fp->track[g_trackMap["CannyTh1"]];
	cannyThr2 = fp->track[g_trackMap["CannyTh2"]];


	int lineOn		= fp->check[g_checkMap["C"]];
	int hatchingOn	= fp->check[g_checkMap["nb`O"]];
	hatchingDiffuse = (fp->check[g_checkMap["gU"]] == 1);
	hatchingIntrType = INTR_NONE;
	if (fp->check[g_checkMap["nb`OԂ(޲Ʊ)"]] == 1) {
		hatchingIntrType = INTR_BILINEAR;
	}
	if (fp->check[g_checkMap["nb`OԂ(޲ޯ)"]] == 1) {
		hatchingIntrType = INTR_BICUBIC;
	}

	makeMask = (fp->check[g_checkMap["}XN쐬"]] == 1);

	cannyOn = (fp->check[g_checkMap["Canny"]] == 1);

	UpdateAnimEffect(fp, fpip);

	switch(hatchingMode){
		case 1: 
			hatchingType = 0;
			DARK=1.0;
			patternOffset=0;
			background=000;
			patInv=false;
			break;

		case 2:
			hatchingType = 1;
			DARK=1.0;
			patternOffset=0;
			background=000;
			patInv=true;
			break;

		case 3:
			hatchingType = 2;
			DARK=0.7;
			patternOffset=1;
			background= makeMask ? 0 : 255;
			patInv=true;
			break; // ʔ]Ł@xŗ

		case 4:
			hatchingType = 3;
			DARK=0.0;
			patternOffset=1;
			background= makeMask ? 0 : 255;
			patInv=true;
			break; // 

		case 5: 
			hatchingType = 4;
			DARK=1.0;
			patternOffset=0;
			background = makeMask ? 0 : 255;
			patInv=true;
			break; // 1̔wi
	}

	patInv ^= (fp->check[g_checkMap["nb`Op^[]"]] == 1);

	if (hatchingMode != 4) {
		DARK *= mDARK;
		addDARK = 0;
	} else {
		addDARK = 255.0*(1-mDARK);
	}

	if (hatching[0] == NULL) {
		//InitHatchingPattern();
		return FALSE;
	}


	if (img0 == NULL) {
		ReleaseImages();
		CreateImages(cvSize(w,h));
	} else {
		CvSize size = cvGetSize(img0);
		if (size.width != w || size.height != h) {
			ReleaseImages();
			CreateImages(cvSize(w,h));
		}
	}

	//AviUtl  OpenCV
	CopyBufToCvBGRImg(buffer0, img0, 0,0,w,h, 0,0, mw,mh);

	if (hatchingOn){
		if (freq == 0) {
			rng_state = cvRNG(((int64)rseed) << 32);
		} else {
			rng_state = cvRNG((((int64)rseed) << 32) + fpip->frame / freq);
		}
		drawHatching(img0, img1);
	}else{
		cvSet(img1, cvScalarAll(background),0);
	}

	if (lineOn){
		drawEdge(img0,img1,2);
	}

	//OpenCV  AviUtl
	CopyCvBGRImgToBuf(img1, buffer0, 0,0,w,h, 0,0, mw,mh);

	return TRUE;
}
